MPI_Comm_split(3)

NAME
MPI_Comm_split - Creates new communicators based on colors and keys

SYNOPSIS
int MPI_Comm_split(MPI_Comm comm, int color, int key, MPI_Comm *newcomm)

INPUT PARAMETERS
comm
    - communicator (handle)
color
    - control of subset assignment (nonnegative integer). Processes with the same color are in the same new communicator
key - control of rank assigment (integer)

OUTPUT PARAMETER
newcomm
    - new communicator (handle)

NOTES
The color must be non-negative or MPI_UNDEFINED .

THREAD AND INTERRUPT SAFETY
This routine is thread-safe. This means that this routine may be safely used by multiple threads without the need for any user-provided thread locks. However, the routine is not interrupt safe. Typically, this is due to the use of memory allocation routines such as malloc or other non-MPICH runtime routines that are themselves not interrupt-safe.

NOTES FOR FORTRAN
All MPI routines in Fortran (except for MPI_WTIME and MPI_WTICK ) have an additional argument ierr at the end of the argument list. ierr is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the call statement. All MPI objects (e.g., MPI_Datatype , MPI_Comm ) are of type INTEGER in Fortran.

ALGORITHM
1. Use MPI_Allgather to get the color and key from each process
2. Count the number of processes with the same color; create a
communicator with that many processes.  If this process has
MPI_UNDEFINED
as the color, create a process with a single member.
3. Use key to order the ranks
4. Set the VCRs using the ordered key values

ERRORS
All MPI routines (except MPI_Wtime and MPI_Wtick ) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with MPI_Comm_set_errhandler (for communicators), MPI_File_set_errhandler (for files), and MPI_Win_set_errhandler (for RMA windows). The MPI-1 routine MPI_Errhandler_set may be used but its use is deprecated. The predefined error handler MPI_ERRORS_RETURN may be used to cause error values to be returned. Note that MPI does not guarentee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.
MPI_SUCCESS
    - No error; MPI routine completed successfully.
MPI_ERR_COMM
    - Invalid communicator. A common error is to use a null communicator in a call (not even allowed in MPI_Comm_rank ).
MPI_ERR_INTERN
    - This error is returned when some part of the MPICH implementation is unable to acquire memory.

SEE ALSO
MPI_Comm_free

LOCATION
comm_split.c